<?php
// +-----------------------------------------------------------------------------+
// | smilies for Geeklog                                                         |
// | Date: Nov, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | index.php                                                                   |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | smilies Plugin Author:                                                      |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

require_once('../lib-common.php');

if (!function_exists('plugin_chkVersion_smilies')){
    //just refresh page to index
    print COM_refresh($_CONF['site_url']);
    exit;
}

#if ($_USER['uid'] < 2 && DB_getItem($_TABLES['smilies_settings'], 'enabled_anonuse') != '1') {
#    $display = COM_siteHeader ('menu', $LANG_SMILIES00[4]);
#    $display .= COM_startBlock ($LANG_SMILIES00[4], '',
#                        COM_getBlockTemplate ('_msg_block', 'header'));
#    $display .= $LANG_SMILIES00[5];
#    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
#    $display .= COM_siteFooter ();
#    COM_accessLog ("An anonymous user, {$_SERVER['REMOTE_ADDR']}, tried to illegally access the smilies index page.");
#    echo $display;
#    exit;
#}

function smilies_list(){
    global $_CONF, $_USER, $_TABLES, $LANG_SMILIES02;
    
    if (!SEC_hasRights('smilies.add')) {
        //if you can add smilies then it makes sense to allow you use of all of them
        //otherwise duplicates are going to be added eventually.
        #$andwhere = " AND available = '1'";
    }
    $result = DB_query("SELECT * FROM {$_TABLES['smilies_data']} WHERE enabled = '1' ORDER BY description");
    
    $t = new Template($_CONF['path'] . 'plugins/smilies/templates/');
    $t->set_file('index', 'index.thtml');
    $blocktitle = $LANG_SMILIES02[4];
    $t->set_var(array(
        'start_block' => COM_startBlock($blocktitle),
        'end_block' => COM_endBlock(),
        'use_msg' => sprintf($LANG_SMILIES02[8], PLG_replaceTags("[smiley: :)]"))
        ));
    
    if (DB_numRows($result) >= 1) {
        $t->set_file(array(
            'table' => 'index_table.thtml',
            'row' => 'index_row.thtml'
            ));
        
        $t->set_var(array(
            'img_heading' => $LANG_SMILIES02[5],
            'code_heading' => $LANG_SMILIES02[6],
            'desc_heading' => $LANG_SMILIES02[7]
            ));
        
        if (SEC_hasRights('smilies.admin')) {
            $t->set_file('editlink','index_editlink.thtml');
            $editlink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall">'
                . $LANG_SMILIES02[11] . '</a>';
            
            $t->set_var('edit_link',$editlink);
            $t->parse('editsmilies_link','editlink');
        }
        
        while($A = DB_fetchArray($result)) {
            $A['description'] = COM_stripslashes($A['description']);
            $A['code'] = COM_stripslashes($A['code']);
            $src = $_CONF['site_url'] . '/smilies/smileyfiles/' . $A['filename'];
            $cssid = ($cssid ==1) ? 2: 1;
            $t->set_var(array(
                'src' => $src,
                'alt' => $A['filename'],
                'title' => $A['description'],
                'typethis' => $A['code'],
                'description' => $A['description'],
                'cssid' => $cssid
                ));
            $t->parse('smiley_item','row',true);
        }
        $t->parse('smilies_table','table');
    } else {
        $t->set_var('empty_listmsg', $LANG_SMILIES02[1]);
    }
    
    if ((DB_getItem($_TABLES['smilies_settings'], 'enabled_useradd') == '1' && $_USER['uid'] > 1) || SEC_hasRights('smilies.add')) {
        $t->set_file('addlink','index_addlink.thtml');
        $add_link = '<a href="' . $_CONF['site_url'] . '/smilies/index.php?op=new">' . $LANG_SMILIES02[3] . '</a>';
        $add_msg = sprintf($LANG_SMILIES02[2], $add_link);
        $t->set_var('add_msg', $add_msg);
        $t->parse('addsmiley_link','addlink');
    }
    
    #if (SEC_hasRights('smilies.admin')) {
    #    $t->set_file('scanlink','index_scanlink.thtml');
    #    $scanlink = '<a href="' . $_CONF['site_url'] . '/smilies/index.php?op=scandir' . '">'
    #        . $LANG_SMILIES02[10] . '</a>';
    #    $scanlink = sprintf($LANG_SMILIES02[9],$scanlink);
    #    $t->set_var('scan_link',$scanlink);
    #    $t->parse('scandir_link', 'scanlink');
    #}
    
    $t->parse ('output', 'index');
    $retval = $t->finish($t->get_var('output'));
    
    return $retval;
}


function smilies_add_smilies_form(){
    global $_CONF, $LANG_SMILIES05;
    
    $t = new Template($_CONF['path'] . 'plugins/smilies/templates/');
    $t->set_file(array(
        'addsmilies' => 'addsmilies.thtml',
        'addrow' => 'add_row.thtml'
        ));
    
    $blocktitle = $LANG_SMILIES05[1];
    $listlink = '<a href="' . $_CONF['site_url'] . '/smilies/index.php?op=new">'
        . $LANG_SMILIES03[15] . '</a>';
    $listlink = sprintf($LANG_SMILIES03[14], $listlink);
    
    $t->set_var(array(
        'start_block' => COM_startBlock($blocktitle),
        'end_block' => COM_endBlock(),
        'use_msg' => $LANG_SMILIES05[2],
        'list_link' => $listlink,
        'action' => $_CONF['site_url'] . '/smilies/index.php?op=new',
        'img_heading' => $LANG_SMILIES05[5],
        'code_heading' => $LANG_SMILIES05[6],
        'desc_heading' => $LANG_SMILIES05[7],
        'enab_heading' => $LANG_SMILIES05[8],
        'submit' => $LANG_SMILIES05[9],
        'reset' => $LANG_SMILIES05[10]
        ));
    
    $i = 0;
    while ($i < 10) {
        $cssid = ($cssid ==1) ? 2: 1;
        $t->set_var('cssid',$cssid);
        $t->set_var('key',$i);
        $t->parse('smiley_item', 'addrow',true);
        $i++;
    }
    
    $t->parse ('output','addsmilies');
    $retval = $t->finish($t->get_var('output'));
    
    return $retval;
}

function smilies_add_smilies($A){
    global $_CONF, $CONF_smilies, $_TABLES;
    
    //print_r($_FILES);
    //print_r($A);
    //exit;
    
    $new_files = array();
    $result = DB_query("SELECT * FROM {$_TABLES['smilies_settings']}");
    $S = DB_fetchArray($result);
    
    if (!SEC_hasRights('smilies.add') || ($S['enabled_useradd'] == '1' && $S['enabled_queue'] == '1')) {
        //storage for queued smilies
        $uploaddir = $_CONF['path_html'] . 'smilies/submissions/';
    } elseif (SEC_hasRights('smilies.add') || $S['enabled_useradd'] == '1') {
        $uploaddir = $_CONF['path_html'] . 'smilies/smileyfiles/';
    }
    
    foreach ($_FILES['smilies']['name'] as $key => $value) {
        if (empty($value)) {
            continue;
        }
        
        $tmp_name = $_FILES['smilies']['tmp_name'][$key];
        $old_name = $value; // same as $_FILES['smilies']['name'][$key]
        $ext = substr($old_name, -3);
        
        //check ext
        if (!in_array($ext, $CONF_smilies['allowed_ext'])) {
            $error++;
            COM_errorLog("Attempted to upload an invalid file type.  See \$CONF_smilies['allowed_ext'] for valid smiley extensions.",1);
            continue;
        }
        
        //check dimensions
        list ($width, $height) = getimagesize($tmp_name);
        if ($width > $S['max_w'] || $height > $S['max_h']) {
            $error = true;
            $dim = true;
            COM_errorLog("Smiley file, $old_name, exceeds max height and/or width set for smilies in config.php.",1);
            continue;
        }
        
        do {
            $file_id = COM_makesid();
            $filename = $file_id . '.' . $ext;
        } while (!empty($new_files) && in_array($filename, $new_files));
        $new_name = $uploaddir . $filename;
        
        //add new filename to array for checking on next loop
        $new_files[] = $filename;
        
        if (!move_uploaded_file($tmp_name, $new_name)) {
            $error = true;
            $move = true;
            COM_errorLog("File, $tmp_name, could not be moved.  Check your directory permissions.");
            continue;
        } else {
            //insert info into db
            
            if (!empty($A['desc'][$key])) {
                $A['desc'][$key] = addslashes (strip_tags (COM_checkWords ($A['desc'][$key])));
            } else {
                $A['desc'][$key] = addslashes(substr($old_name, 0, -4));
            }
            $A['code'][$key] = addslashes(strip_tags(COM_checkWords($A['code'][$key])));
            if (!empty($A['code'][$key])) {
                if ($A['enabled'][$key] != '1') {
                    $A['enabled'][$key] = '0';
                }
            } else {
                //no code results in a disabled smiley :(
                $A['enabled'][$key] = '0';
            }
            
            if (!SEC_hasRights('smilies.add') || ($S['enabled_useradd'] == '1' && $S['enabled_queue'] == '1')) {
                //submit to queue
                smilies_add_to_queue($file_id, $filename, $A['code'][$key], $A['desc'][$key]);
            } elseif (SEC_hasRights('smilies.add') || $S['enabled_useradd'] == '1') {
                //direct submit
                smilies_insert_single_smiley($file_id, $filename, $A['code'][$key], $A['desc'][$key], $A['enabled'][$key]);
            }
        }
    }
    
    if (!SEC_hasRights('smilies.add') || ($S['enabled_useradd'] == '1' && $S['enabled_queue'] == '1')) {
        $msg = '9';
    } elseif (SEC_hasRights('smilies.add') || $S['enabled_useradd'] == '1') {
        if ($error && SEC_hasRights('smilies.admin')) {
            $msg = '8';
        } elseif ($error) {
            $msg = '10';
        } else {
            $msg = '7';
        }
    }
    
    return COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=list&msg=' . $msg);
}

function smilies_insert_single_smiley($id, $filename, $code, $description, $enabled){
    global $_TABLES, $_USER;
    
    DB_query("INSERT INTO {$_TABLES['smilies_data']} SET id = '$id',
        filename = '$filename', code = '$code', description = '$description',
        owner_id = '{$_USER['uid']}', enabled = '$enabled'");
}

function smilies_add_to_queue($id, $filename, $code, $description){
    global $_TABLES, $_USER;
    
    DB_query("INSERT INTO {$_TABLES['smilies_submissions']} SET id = '$id',
        filename = '$filename', code = '$code', description = '$description',
        owner_id = '{$_USER['uid']}', enabled = '0'");
    
    //send notification
    smilies_sendNotification($id, $filename, $code, $description);
}


/*
 main function
*/

if (isset($_REQUEST['op'])) {
    $op = COM_applyFilter($_REQUEST['op']);
} elseif (isset($_REQUEST['mode'])) {
    $op = COM_applyFilter($_REQUEST['mode']);
} else $op = '';

if (isset($_REQUEST['msg'])) {
    $msg = COM_applyFilter($_REQUEST['msg'], true);
} else $msg = '';

if (isset($_POST['submit']) && $_POST['submit'] == $LANG_SMILIES03[18]) {
    print COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=list');
    exit;
}

$display = COM_siteHeader();

if (!empty($msg)) {
    //msg block
    $display .= COM_startBlock($LANG_SMILIES04[2],'','blockheader-message.thtml');
    $display .= $LANG_SMILIES04[$msg];
    $display .= COM_endBlock('blockfooter-message.thtml');
}

if ($op == 'list') {
    $display .= smilies_list();
} elseif ($op == 'new') {
    //check perms
    if ((DB_getItem($_TABLES['smilies_settings'], 'enabled_useradd') == '1'
        && $_USER['uid'] > 1) || SEC_hasRights('smilies.add')) {
        if (!is_writable($_CONF['path_html'].'smilies/smileyfiles/')) {
            //refresh to list w/msg.
            print COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=list&msg=1');
            exit;
        } elseif (isset($_POST['submit']) && $_POST['submit'] == $LANG_SMILIES05[3]) {
            print smilies_add_smilies($_POST);
            exit;
        } else {
            $display .= smilies_add_smilies_form();
        }
    } else {
        //refresh to list w/o msg
        print COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=list');
        exit;
    }
}

$display .= COM_siteFooter();

echo $display;
?>